(* Si m::p est full, m est le hmonom                    *)
(* idem pour le hterm, le hcoef.                        *)
(* ex f1,f2, tq   f = f1 + (c,t) + f2,  les termes de f1        *)
(* sont plus petits, ceux de f2 plus grands que t               *)
(* (c,t) <> 0                                                   *)
(* si t pas dans p, alors (c,t)+p <> 0                          *)
(* si (c,t)::p est full, alors il est non nul                   *)
(* si (c,t)::p est full alors t pas dans p                      *)
(* si t > p et p full, alors t > que tous les termes de p       *)
(* si t ds p, et <> du hterm, alors < au hterm                  *)
(* si plus gd que le hterm, alors pas dans le pol.              *)
(* si plus gd que tous les termes de p, alors pas dans p        *)
(* le hterm de (c,t)::0 est t                                   *)
(* idem hcoef                                                   *)
(* ... et plein d'autres trucs comme ca (tres arithmetique)     *)




Require Export S_poly_nuevo2_tes.

(* Pasado a Hmtc.v

Lemma equm_full_hmonom: (c:Q)(t:term)(q:pol)
   (full_pol (cpol (c,t) q))->
    (equm (hmonom (cpol (c,t) q)) (c,t)).
Intros.
Replace hmonom with [x:pol](fst_term (fun_can x)).
Apply equm_trans with (fst_term (cpol (c,t) q)).
Apply fst_equm.
Auto.
 
Simpl.
(Apply equmoni; Trivial).
(Inversion H; Auto).
 
Trivial.
Save.
Hints Resolve equm_full_hmonom.

Lemma full_hterm: (c:Q)(t:term)(q:pol)
   (full_pol (cpol (c,t) q))->(hterm (cpol (c,t) q))=t.
Intros.
Inversion H.
Cut (equm (hmonom (cpol (c,t) q)) (c,t)).
Replace hterm with [x:pol](mon_term (hmonom x)).
Intros e; Inversion e.
(Simpl; Auto).
 
Auto.

Auto.
Save.
Hints Resolve full_hterm.

Lemma full_hcoef: (c:Q)(t:term)(q:pol)
   (full_pol (cpol (c,t) q))->(eqQ (hcoef (cpol (c,t) q)) c).
Intros.
Inversion H.
Cut (equm (hmonom (cpol (c,t) q)) (c,t)).
Replace hcoef with [x:pol](mon_coef (hmonom x)).
(Intros e; Inversion e).
Simpl; Auto.
 
Auto.
 
Auto.
Save.
Hints Resolve full_hcoef.

*)

(* Pasados a coeficiente_tes.

Lemma gen_split_pol: (f:pol)(full_term_pol f)->
 (t:term)(full n t)->
   (EX f1 | (full_term_pol f1)/\
            ((t':term)(term_in_pol f1 t')->(Ttm t t'))
     & (EX f2 | (full_term_pol f2)/\
            ((t':term)(term_in_pol f2 t')->(Ttm t' t))
      & (equpol f (suma_app f1 (suma_app 
         (cpol ((coef f t),t) vpol) f2))))).
Induction f.
Intros.
Split with vpol.
(Split; Auto).
(Intros t' e; Elim e; Auto).
 
Split with vpol.
(Split; Auto).
(Intros t' e; Elim e; Auto).
 
Simpl.
Auto.

(*   Caso de f = (cpol m p)   *) 
 
(Induction m; Intros).
Inversion H0.
(Elim (Ttm_total y0 t n); Trivial).
Intros.
(Elim y1; Intros; Clear y1).

(*   Caso de (Ttm y0 t)   *)

(Elim H with t; Trivial).
Intros.
(Elim H7; Intros).
(Elim H8; Intros).
(Elim H11; Intros).
Clear H11 H8 H7.
Split with x.
(Split; Auto).
 
Split with (cpol (y,y0) x0).
Split.
Apply full_term_pol_cons.
Trivial.
 
Trivial.
 
Intros.
Cut t'=y0\/(term_in_pol x0 t'); Intros.
(Elim H8; Intros; Clear H8).
(Rewrite H11; Trivial).
 
(Apply H14; Auto).
 
Apply split_term_in_pol_cons with y; Auto.
 
Apply equpol_tran
 with (cpol (y,y0)
        (suma_app x (suma_app (cpol ((coef p t),t) vpol) x0))).
Auto.
 
Apply equpol_tran
 with (suma_app x
        (cpol (y,y0) (suma_app (cpol ((coef p t),t) vpol) x0))).
Auto.
 
(Apply equpol_ss; Trivial).
Apply equpol_tran
 with (cpol ((coef (cpol (y,y0) p) t),t)
        (cpol (y,y0) (suma_app vpol x0))).
Apply equpol_tran
 with (suma_app (cpol ((coef p t),t) vpol) (cpol (y,y0) x0)).
Auto.
 
Apply equpol_tran
 with (cpol ((coef p t),t) (cpol (y,y0) (suma_app vpol x0))).
Auto.
 
Apply eq_mon_cpol.
Simpl.
Right .
Split; Trivial.
Elim (eq_tm_dec t y0); Auto.
Intros.
(Cut ~y0=t; Intros).
(Elim H7; Auto).
 
(Apply Ttm_strict with n; Trivial).
 
Auto.

(*   Caso de (Ttm t y0)   *)

Elim H with t; Trivial.
Intros.
(Elim H7; Intros).
(Elim H8; Intros).
(Elim H11; Intros).
Clear H11 H8 H7.
Split with (cpol (y,y0) x).
Split.
(Apply full_term_pol_cons; Trivial).
 
Intros.
Cut t'=y0\/(term_in_pol x t'); Intros.
(Elim H8; Intros; Clear H8).
(Rewrite H11; Trivial).
 
(Apply H10; Auto).
 
Apply split_term_in_pol_cons with y; Auto.
 
Split with x0.
(Split; Trivial).
 
Apply equpol_tran
 with (cpol (y,y0)
        (suma_app x (suma_app (cpol ((coef p t),t) vpol) x0))).
Auto.
 
Simpl.
(Apply equpol_cpol2; Trivial).
(Apply equpol_ss; Trivial).
Apply eq_mon_cpol.
Simpl.
Right .
(Split; Trivial).
(Elim (eq_tm_dec t y0); Auto).
Intros.
(Cut ~t=y0; Intros).
(Elim H7; Auto).
 
Apply Ttm_strict with n; Trivial.

(* Caso y0=t  *)
 
Intros.
Elim H with t.
Intros.
(Elim H7; Intros).
(Elim H8; Intros).
(Elim H11; Intros).
Clear H11 H8 H7.
Split with x.
(Split; Auto).
 
Split with x0.
(Split; Auto).
 
Apply equpol_tran
 with (cpol (y,y0)
        (suma_app x (suma_app (cpol ((coef p t),t) vpol) x0))).
Auto.
 
Rewrite y1.
Apply equpol_tran
 with (suma_app x (cpol (y,t) (suma_app (cpol ((coef p t),t) vpol) x0))).
Auto.
 
(Apply equpol_ss; Trivial).
Apply equpol_tran
 with (suma_app (cpol ((coef p t),t) vpol) (cpol (y,t) x0)).
Auto.
 
Simpl.
Elim (eq_tm_dec t t).
Intros.
Apply equpol_tran with (cpol ((plusQ (coef p t) y),t) x0).
Auto.
 
Auto.
 
(Intro e; Elim e; Auto).
 
Trivial.
 
Trivial.
Save.
Hints Resolve gen_split_pol. 


Lemma split_pol: (f:pol)(full_term_pol f)->
 (t:term)(term_in_pol f t)->
   (EX f1 | (full_term_pol f1)/\
            ((t':term)(term_in_pol f1 t')->(Ttm t t'))
     & (EX f2 | (full_term_pol f2)/\
            ((t':term)(term_in_pol f2 t')->(Ttm t' t))
      & (equpol f (suma_app f1 (suma_app 
         (cpol ((coef f t),t) vpol) f2))))).
Intros.
Cut (full n t).
Intros.
Apply gen_split_pol.
Auto.
 
Auto.
 
(Apply full_coef with f; Auto).
Save.
Hints Resolve split_pol.



Lemma n_zmonom_n_vpol: (m:monom)(full_mon n m)->
   (~(z_monom m))->~(equpol (cpol m vpol) vpol).
Induction m; Intros.
Unfold z_monom in H0.
Cut ~(same_pol (cpol (y,y0) vpol) vpol).
Intros.
Red in H1.
Red.
Intros.
Apply H1.
Auto.
 
Red.
Intros.
Cut (eqQ (coef (cpol (y,y0) vpol) y0) (coef vpol y0)).
Intros.
Cut (eqQ (coef (cpol (y,y0) vpol) y0) y).
Intros.
Cut (eqQ (coef vpol y0) OQ).
Intros.
Cut (eqQ y OQ).
Intros.
Auto.
 
(Apply eqQ_trans with (coef (cpol (y,y0) vpol) y0); Auto).
 
Auto.
 
Simpl.
Elim (eq_tm_dec y0 y0).
Auto.
 
Intros.
(Elim y1; Auto).
 
Auto.
Save.
Hints Resolve n_zmonom_n_vpol. 


Lemma no_equpol_Ttm: (p:pol)(full_term_pol p)->
 (k:Q)(~(eqQ k OQ))->(t:term)(full n t)->
  (no_term_in_pol p t)->(~(equpol 
     (suma_app (cpol (k,t) vpol) p) vpol)).
Intros.
Red; Intros.
Red in H2.
Simpl in H3.
Cut (eqQ (coef (cpol (k,t) p) t) (coef vpol t)); Intros.
Cut (eqQ (coef (cpol (k,t) p) t) (plusQ k (coef p t))).
Intros.
Cut (eqQ (coef (cpol (k,t) p) t) OQ).
Intros.
(Cut (eqQ (coef (cpol (k,t) p) t) k); Intros).
(Cut (eqQ k OQ); Intros).
(Elim H0; Auto).
 
(Apply eqQ_trans with (coef (cpol (k,t) p) t); Auto).
 
(Apply eqQ_trans with (plusQ k (coef p t)); Auto).
(Apply eqQ_trans with (plusQ k OQ); Auto).
 
Auto.
 
Simpl.
(Elim (eq_tm_dec t t); Intros).
Trivial.
 
(Elim y; Auto).
 
Auto.
Save.
Hints Resolve no_equpol_Ttm.

*)

(* Pasado a pol_can.

Lemma full_no_term: (y:Q)(y0:term)(p:pol)
 (full_pol (cpol (y,y0) p))->(no_term_in_pol p y0).
Induction p.
Intros.
Red.
Auto.
 
Induction m; Intros.
Inversion H0.
Red.
Inversion H6.
Inversion H7.
Apply eqQ_trans with (coef p0 y0).
Cut ~y2=y0.
Auto.
 
Apply Ttm_strict with n; Trivial.
 
Change (no_term_in_pol p0 y0).
Apply H.
(Apply full_pol_cons; Auto).
(Apply low_trans with y2; Auto).
Save.


Lemma term_in_Ttm_pol_hterm: (p:pol)(full_pol p)->
 (y0,t:term)(full n y0)->(full n t)->(low_pol y0 p)->
  (term_in_pol p t)->(Ttm t y0).
Induction p.
Intros.
Elim H3; Auto.
 
Induction m; Intros.
Inversion H0.
Inversion H3.
Elim (eq_tm_dec t y0); Intros.
(Rewrite y2; Trivial).
 
(Apply Ttm_trans with y0 n; Trivial).
(Apply H; Auto).
Cut t=y0\/(term_in_pol p0 t); Intros.
Elim H17; Intros; Clear H17.
Elim y2; Auto.
 
Trivial.
 
Apply split_term_in_pol_cons with y; Auto.
Save.

*)

(* Pasado a Hmtc.v

Lemma full_Ttm_pol_hterm:(f:pol)(full_pol f)->
 (t:term)(term_in_pol f t)->~t=(hterm f)->(Ttm t (hterm f)).
Induction f.
Intros.
Elim H0; Auto.

Induction m; Intros.
(Cut (hterm (cpol (y,y0) p))=y0; Intros).
Rewrite H3.
Rewrite H3 in H2.
Inversion H0.
(Cut (term_in_pol p t); Intros).
Apply term_in_Ttm_pol with p; Trivial.

Cut t=y0\/(term_in_pol p t).
Intros.
(Elim H11; Intros).
(Elim H2; Auto).

Trivial.

(Apply split_term_in_pol_cons with y; Auto).

Auto.
Save.


Lemma Ttm_pol_hterm:(f:pol)(full_term_pol f)->
 (t:term)(term_in_pol f t)->(~(t=(hterm f)))->
    (Ttm t (hterm f)).
Intros.
Elim (can_fun f).
Intros.
(Elim y; Intros; Clear y).
Replace (hterm f) with (hterm x).
(Apply full_Ttm_pol_hterm; Trivial).
(Apply comp_term_in_pol with f; Auto).
 
(Replace (hterm x) with (hterm f); Auto).
 
Auto.
 
Auto.
Save.
Hints Resolve Ttm_pol_hterm.

*)

(* Pasado a Hmtc.v

Lemma Ttm_hterm: (f:pol)(full_term_pol f)->
 (t:term)(full n t)->(Ttm (hterm f) t)->
    (no_term_in_pol f t).
Intros.
(Elim (dec_term_in_pol f t); Trivial).
Intros.
(Cut ~(equpol f vpol); Intros).
(Cut (Ttm t (hterm f)); Intros).
(Cut ~((Ttm (hterm f) t)/\(Ttm t (hterm f))); Intros).
(Elim H4; Auto).
 
(Apply Ttm_antisym with n; Trivial).
Auto.
 
(Apply Ttm_pol_hterm; Auto).
Red.
Intro.
Cut (hterm f)=t; Auto.
Change ~(hterm f)=t.
(Apply Ttm_strict with n; Trivial).
Auto.
 
(Red; Intros).
Red in y.
Red in y.
Apply y.
(Apply eqQ_trans with (coef vpol t); Auto).
Save.
Hints Resolve Ttm_hterm.
*)

(* Pasado a coeficiente_tes.

Lemma Ttm_hterm_bis: (f:pol)(full_term_pol f)->
 (t:term)(full n t)->
  ((t':term)(term_in_pol f t')->(Ttm t' t))->
     (no_term_in_pol f t).
Intros.
Elim (dec_term_in_pol f t); Trivial.
Intros.
Cut ~(equpol f vpol); Intros.
(Cut (Ttm t t); Intros).
Absurd (Ttm t t).
Auto.
 
Trivial.
 
(Apply H1; Trivial).
 
(Apply term_in_pol_nvpol with t; Auto).
Save.
Hints Resolve Ttm_hterm_bis.

*)

(* Pasado a Hmtv.v

Lemma term_monom_hterm: (k:Q)(t:term)(full n t)->
   (~(eqQ k OQ))->(hterm (cpol (k,t) vpol))=t.
Intros.
(Cut (full_pol (cpol (k,t) vpol)); Intros).
(Apply full_hterm; Auto).
 
Auto.
Save.
Hints Resolve term_monom_hterm.


Lemma eq_coef_monom: (k:Q)(t:term)(full n t)->
   (eqQ k (hcoef (cpol (k,t) vpol))).
Intros.
(Elim (decQ k); Intros).
(Apply eqQ_trans with OQ; Auto).
Apply eqQ_trans with (coef (cpol (k,t) vpol) (hterm (cpol (k,t) vpol))).
Replace (hterm (cpol (k,t) vpol)) with (hterm vpol).
Simpl.
Elim (eq_tm_dec (hterm vpol) t).
Auto.
 
Auto.
 
Auto.
 
Auto.
 
Apply eqQ_trans with (coef (cpol (k,t) vpol) (hterm (cpol (k,t) vpol))).
Replace (hterm (cpol (k,t) vpol)) with t.
Simpl.
Elim (eq_tm_dec t t).
Auto.
 
Intros.
(Elim y0; Auto).
 
Symmetry.
Apply term_monom_hterm; Trivial.
 
Auto.
Save.
Hints Resolve eq_coef_monom.


Lemma hcoef_vpol: (eqQ (hcoef vpol) OQ).
(Apply eqQ_trans with (hcoef (cpol (OQ,(n_term_O n)) vpol)); Auto).
Save.

*)

(* Pasado a coeficiente_tes.

Lemma coef_Ttm_split_pol: (f,f1,f2:pol)(t:term)(full n t)->
 (full_term_pol f)->(full_term_pol f1)->(full_term_pol f2)->
  (equpol f (suma_app f1 
     (suma_app (cpol ((coef f t),t) vpol) f2)))->
   (t0:term)(full n t0)->(Ttm t0 t)->
    ((t':term)(term_in_pol f1 t')->(Ttm t t'))->
     (eqQ (coef f2 t0) (coef f t0)).
Intros.
Cut (equpol f (suma_app (suma_app f1 (cpol ((coef f t),t) vpol)) f2)).
Intros.
Apply eqQ_trans
 with (coef (suma_app (suma_app f1 (cpol ((coef f t),t) vpol)) f2) t0).
Apply eqQ_trans
 with (plusQ (coef (suma_app f1 (cpol ((coef f t),t) vpol)) t0)
        (coef f2 t0)); Auto.
Apply eqQ_trans with (plusQ OQ (coef f2 t0)).
Apply eqQ_trans with (plusQ (coef f2 t0) OQ); Auto.
 
Apply plusQ_comp; Trivial.
Apply eqQ_sym.
Apply eqQ_trans
 with (plusQ (coef f1 t0) (coef (cpol ((coef f t),t) vpol) t0)).
Auto.
 
Apply plusQ_zero.
Change (no_term_in_pol f1 t0).
Apply Ttm_no_term_in_pol; Trivial.
Intros.
(Apply Ttm_trans with t n; Trivial).
(Apply full_coef with f1; Trivial).
 
(Apply H6; Auto).
 
(Cut ~t=t0; Intros).
(Apply eqQ_trans with (coef vpol t0); Auto).
 
Red.
Intros.
(Cut t0=t; Auto).
Change ~t0=t.
(Apply Ttm_strict with n; Trivial).
 
Auto.
 
Apply equpol_tran
 with (suma_app f1 (suma_app (cpol ((coef f t),t) vpol) f2)); Auto.
Save.
Hints Resolve coef_Ttm_split_pol.


Lemma split_term_in_pol: (f1,f2:pol)
 (full_term_pol f1)->(full_term_pol f2)->
  (k:Q)(t,t0:term)(full n t)->(full n t0)->
   (term_in_pol (suma_app f1 (suma_app 
                 (cpol (k,t) vpol) f2)) t0)->
    (Ttm t0 t)->((t':term)(term_in_pol f1 t')->(Ttm t t'))->
       (term_in_pol f2 t0).
Intros.
Cut (term_in_pol (suma_app (suma_app f1 (cpol (k,t) vpol)) f2) t0);
Intros.
Cut (no_term_in_pol (suma_app f1 (cpol (k,t) vpol)) t0); Intros.
Red in H6.
Red in H7.
Red.
Apply comp_nOQ
 with (coef (suma_app (suma_app f1 (cpol (k,t) vpol)) f2) t0).
(Apply eqQ_trans
  with (plusQ (coef (suma_app f1 (cpol (k,t) vpol)) t0) (coef f2 t0));
 Auto).
(Apply eqQ_trans with (plusQ OQ (coef f2 t0)); Auto).
(Apply eqQ_trans with (plusQ (coef f2 t0) OQ); Auto).

Auto.
 
Red.
Apply eqQ_trans with (plusQ (coef f1 t0) (coef (cpol (k,t) vpol) t0)).
Auto.
 
Apply plusQ_zero.
Change (no_term_in_pol f1 t0).
(Apply Ttm_no_term_in_pol; Trivial).
Intros.
Apply Ttm_trans with t n; Trivial.
Apply full_coef with f1; Trivial.
 
(Apply H5; Auto).
 
Cut ~t=t0; Intros.
Apply eqQ_trans with (coef vpol t0); Auto.
 
Red.
Intros.
Cut t0=t; Auto.
Change ~t0=t.
Apply Ttm_strict with n; Trivial.
 
Apply comp_term_in_pol
 with (suma_app f1 (suma_app (cpol (k,t) vpol) f2)); Auto.
Save.
Hints Resolve split_term_in_pol.

*)

(*

Lemma aux_hterm_suma_Ttm: (f,h:pol)(full_term_pol f)->
 (full_term_pol h)->(~(equpol f vpol))->
  (Ttm (hterm h) (hterm f))->
   (term_in_pol (suma_app f h) (hterm f)).
Intros.
Red.
Apply comp_nOQ with (plusQ (coef h (hterm f)) (coef f (hterm f))).
(Apply eqQ_trans with (plusQ (coef f (hterm f)) (coef h (hterm f)));
 Auto).
 
Apply plusQ_zero_nzero.
Change (no_term_in_pol h (hterm f)).
Auto.
 
(Apply comp_nOQ with (hcoef f); Auto).
Save.


Lemma aux1_hterm_suma_Ttm: (f:pol)(full_term_pol f)->
 (t:term)(term_in_pol f t)->
  ((t':term)(term_in_pol f t')->(~t=t')->(Ttm t' t))->
   (t=(hterm f)).
Intros.
(Elim (eq_tm_dec t (hterm f)); Intros; Trivial).
(Cut (Ttm t (hterm f)); Intros).
(Cut (Ttm (hterm f) t); Intros).
(Cut ~((Ttm t (hterm f))/\(Ttm (hterm f) t)); Intros).
(Elim H4; Auto).
 
Apply Ttm_antisym with n.
(Apply full_coef with f; Auto).
 
Auto.
 
Apply H1.
(Apply occ_n_vpol; Auto).
(Apply term_in_pol_nvpol with t; Auto).
 
Trivial.
 
(Apply Ttm_pol_hterm; Auto).
Save.
*)

(* Pasado a coeficiente con el nombre de term_in_sum

Lemma aux2_hterm_suma_Ttm: (f,g:pol)(full_term_pol f)->
 (full_term_pol g)->(t:term)(term_in_pol (suma_app f g) t)->
  (term_in_pol f t)\/(term_in_pol g t).
Intros.
Red in H1.
Unfold term_in_pol.
Cut (eqQ (coef (suma_app f g) t) (plusQ (coef f t) (coef g t))).
Intros.
Elim (decQ (coef f t)).
Intros.
Right .
Apply comp_nOQ with (coef (suma_app f g) t).
(Apply eqQ_trans with (plusQ (coef f t) (coef g t)); Auto).
(Apply eqQ_trans with (plusQ OQ (coef g t)); Auto).
(Apply eqQ_trans with (plusQ (coef g t) OQ); Auto).
 
Auto.
 
Intros.
(Left ; Auto).
 
Auto.
Save.


*)

(*
Lemma hterm_suma_Ttm: (f,h:pol)(full_term_pol f)->(full_term_pol h)->
 (~(equpol f vpol))->(Ttm (hterm h) (hterm f))->
    (hterm (suma_app f h))=(hterm f).
Intros.
Cut (term_in_pol (suma_app f h) (hterm f)).
Intros.
Symmetry.
Apply aux1_hterm_suma_Ttm.
Auto.
 
Auto.
 
Intros.
(Cut (term_in_pol f t')\/(term_in_pol h t'); Intros).
(Elim H6; Intros; Clear H6).
Auto.
 
(Cut t'=(hterm h)\/(Ttm t' (hterm h)); Intros).
(Elim H6; Intros; Clear H6).
(Rewrite <- H8 in H2; Auto).
 
(Apply Ttm_trans with (hterm h) n; Auto).
(Apply full_coef with h; Auto).
 
(Elim (eq_tm_dec t' (hterm h)); Intros).
(Left ; Trivial).
 
Right .
(Apply Ttm_pol_hterm; Auto).
 
(Apply term_in_sum; Auto).
 
(Apply aux_hterm_suma_Ttm; Auto).
Save.





Lemma hcoef_suma_Ttm: (f,h:pol)(full_term_pol f)->
 (full_term_pol h)->(~(equpol f vpol))->
 (Ttm (hterm h) (hterm f))->
  (eqQ (hcoef (suma_app f h)) (hcoef f)). 
Intros.
(Apply eqQ_trans with (coef (suma_app f h) (hterm (suma_app f h)));
 Auto).
(Apply eqQ_trans with (coef f (hterm f)); Auto).
Replace (hterm (suma_app f h)) with (hterm f).
(Apply eqQ_trans with (plusQ (coef f (hterm f)) (coef h (hterm f)));
 Auto).
(Apply eqQ_trans with (plusQ (coef f (hterm f)) OQ); Auto).
Apply plusQ_comp; Trivial.
Change (no_term_in_pol h (hterm f)).
Apply Ttm_hterm; Auto.
 
Symmetry.
(Apply hterm_suma_Ttm; Auto).
Save.
*)

(*

Lemma term_in_Ttm_hterm: (f,h:pol)(full_term_pol f)->
 (full_term_pol h)->(t:term)(term_in_pol f t)->
((t1:term)(term_in_pol h t1)->(Ttm (hterm f) t1))->
(term_in_pol (suma_app f h) t).
Intros.
(Cut ~(equpol f vpol); Intros).
Red in H1.
Red.
Apply comp_nOQ with (plusQ (coef f t) (coef h t)); Auto.
Apply comp_nOQ with (plusQ (coef h t) (coef f t)); Auto.
Apply plusQ_zero_nzero; Trivial.
(Elim (eq_tm_dec t (hterm f)); Intros).
Rewrite <- y in H2.
Change (no_term_in_pol h t).
(Elim (dec_term_in_pol h t); Trivial).
Intros.
Cut (Ttm t t); Intros.
Cut ~t=t; Intros.
(Elim H5; Auto).
 
Apply Ttm_strict with n; Trivial.
(Apply full_coef with h; Trivial).
 
(Apply full_coef with h; Trivial).
 
Auto.
 
(Cut (t1:term)(term_in_pol h t1)->(Ttm t t1); Intros).
Change (no_term_in_pol h t).
(Elim (dec_term_in_pol h t); Trivial).
Intros.
Cut (Ttm t t); Intros.
Cut ~t=t; Intros.
(Elim H6; Auto).
 
Apply Ttm_strict with n; Trivial.
(Apply full_coef with h; Trivial).
 
(Apply full_coef with h; Trivial).
 
Auto.
 
Apply Ttm_trans with (hterm f) n.
Apply full_coef with f; Trivial.
 
Auto.
 
(Apply full_coef with h; Trivial).
 
Apply Ttm_pol_hterm; Trivial.
 
Auto.
 
(Apply term_in_pol_nvpol with t; Trivial).

Save.

*)






(*


Lemma term_in_Ttm_hterm: (f,h:pol)(full_term_pol f)->
 (full_term_pol h)->(t:term)(term_in_pol f t)->
((t1:term)(term_in_pol h t1)->(Ttm (hterm f) t1))->
(term_in_pol (suma_app f h) t).
Intros.
Cut ~(equpol f vpol); Intros.
Red in H1.
Red.
(Apply comp_nOQ with (plusQ (coef f t) (coef h t)); Auto).
(Apply comp_nOQ with (plusQ (coef h t) (coef f t)); Auto).
(Apply plusQ_zero_nzero; Trivial).
Elim (eq_tm_dec t (hterm f)); Intros.
Rewrite <- y in H2.
Change (no_term_in_pol h t).
Elim (dec_term_in_pol h t); Trivial.
Intros.
(Cut (Ttm t t); Intros).
(Cut ~t=t; Intros).
Elim H5; Auto.
 
(Apply Ttm_strict with n; Trivial).
Apply full_coef with h; Trivial.
 
Apply full_coef with h; Trivial.
 
Auto.
 
Cut (t1:term)(term_in_pol h t1)->(Ttm t t1); Intros.
Change (no_term_in_pol h t).
Elim (dec_term_in_pol h t); Trivial.
Intros.
(Cut (Ttm t t); Intros).
(Cut ~t=t; Intros).
Elim H6; Auto.
 
(Apply Ttm_strict with n; Trivial).
Apply full_coef with h; Trivial.
 
Apply full_coef with h; Trivial.
 
Auto.
 
Apply Ttm_trans with (hterm f) n.
Auto.
 
(Apply full_coef with f; Trivial).
 
Auto.
 
Apply full_coef with h; Trivial.
 
Auto.
 
Apply term_in_pol_nvpol with t; Trivial.
Save.
*)

(*

Lemma coef_suma_Ttm: (f,h:pol)(full_term_pol f)->
 (full_term_pol h)->(t:term)(term_in_pol f t)->
((t1:term)(term_in_pol h t1)->(Ttm (hterm f) t1))->
  (eqQ (coef f t) (coef (suma_app f h) t)).
Intros.
(Cut ~(equpol f vpol); Intros).
(Apply eqQ_trans with (plusQ (coef f t) (coef h t)); Auto).
(Apply eqQ_trans with (plusQ (coef f t) OQ); Auto).
(Apply plusQ_comp; Trivial).
Elim (eq_tm_dec t (hterm f)); Intros.
Rewrite <- y in H2.
Apply eqQ_sym.
Change (no_term_in_pol h t).
Elim (dec_term_in_pol h t); Trivial.
Intros.
(Cut (Ttm t t); Intros).
(Cut ~t=t; Intros).
Elim H5; Auto.
 
(Apply Ttm_strict with n; Trivial).
Apply full_coef with h; Trivial.
 
Apply full_coef with h; Trivial.
 
Auto.
 
Cut (t1:term)(term_in_pol h t1)->(Ttm t t1); Intros.
Apply eqQ_sym.
Change (no_term_in_pol h t).
Elim (dec_term_in_pol h t); Trivial.
Intros.
(Cut (Ttm t t); Intros).
(Cut ~t=t; Intros).
Elim H6; Auto.
 
(Apply Ttm_strict with n; Trivial).
Apply full_coef with h; Trivial.
 
Apply full_coef with h; Trivial.
 
Auto.
 
Apply Ttm_trans with (hterm f) n.
(Apply full_coef with f; Trivial).
 
Auto.
 
Apply full_coef with h; Trivial.
 
(Apply Ttm_pol_hterm; Trivial).
 
Auto.
 
(Apply term_in_pol_nvpol with t; Trivial).
Save.
Hints Resolve coef_suma_Ttm.

*)




(*




Lemma coef_suma_Ttm: (f,h:pol)(full_term_pol f)->
 (full_term_pol h)->(t:term)(term_in_pol f t)->
((t1:term)(term_in_pol h t1)->(Ttm (hterm f) t1))->
  (eqQ (coef f t) (coef (suma_app f h) t)).
Intros.
Cut ~(equpol f vpol); Intros.
Apply eqQ_trans with (plusQ (coef f t) (coef h t)); Auto.
Apply eqQ_trans with (plusQ (coef f t) OQ); Auto.
Apply plusQ_comp; Trivial.
(Elim (eq_tm_dec t (hterm f)); Intros).
Rewrite <- y in H2.
Apply eqQ_sym.
Change (no_term_in_pol h t).
(Elim (dec_term_in_pol h t); Trivial).
Intros.
Cut (Ttm t t); Intros.
Cut ~t=t; Intros.
(Elim H5; Auto).
 
Apply Ttm_strict with n; Trivial.
(Apply full_coef with h; Trivial).
 
(Apply full_coef with h; Trivial).
 
Auto.
 
(Cut (t1:term)(term_in_pol h t1)->(Ttm t t1); Intros).
Apply eqQ_sym.
Change (no_term_in_pol h t).
(Elim (dec_term_in_pol h t); Trivial).
Intros.
Cut (Ttm t t); Intros.
Cut ~t=t; Intros.
(Elim H6; Auto).
 
Apply Ttm_strict with n; Trivial.
(Apply full_coef with h; Trivial).
 
(Apply full_coef with h; Trivial).
 
Auto.
 
Apply Ttm_trans with (hterm f) n.
Auto.
 
Apply full_coef with f; Trivial.
 
Auto.
 
(Apply full_coef with h; Trivial).
 
Auto.
 
Apply term_in_pol_nvpol with t; Trivial.
Save.
Hints Resolve coef_suma_Ttm.












Lemma hterm_mult_m2: (f:pol)(full_term_pol f)->
 (~(equpol f vpol))->(k:Q)(~(eqQ k OQ))->
  (t:term)(full n t)->(term_div (hterm f) t)->
   (hterm (mult_m f (k,(div_term t (hterm f)))))=t.
Intros.
Transitivity (term_mult (hterm f) (mon_term (k,(div_term t (hterm f))))).
Apply hterm_mult_m; Auto.
 
Simpl.
Symmetry.
(Apply divis_im_divt with n; Auto).
Save.









Lemma hcoef_mult2: (f:pol)(full_term_pol f)->
 (~(equpol f vpol))->(k:Q)(~(eqQ k OQ))->
  (t:term)(full n t)->
   (eqQ (hcoef (mult_m f (k,(div_term t (hterm f)))))
   (multQ (hcoef f) (mon_coef (k,(div_term t (hterm f)))))).
Intros.
Apply eqQ_trans
 with (multQ (hcoef f) (mon_coef (k,(div_term t (hterm f))))).
Apply hcoef_mult; Auto.
 
Simpl.
Auto.
Save.









Lemma aux1_hterm_eq_suma_Ttm: (f,g:pol)(full_term_pol f)->
  (full_term_pol g)->((hterm f)=(hterm g))->
   (t:term)(term_in_pol (suma_app f g) t)->
    (~(t=(hterm f)))->(Ttm t (hterm f)).
Intros.
(Elim term_in_sum with f g t; Trivial).
Auto.
 
Rewrite H1; Intros.
Rewrite H1 in H3; Auto.
Save.

Lemma aux2_hterm_eq_suma_Ttm: (f,g:pol)(full_term_pol f)->
  (full_term_pol g)->((hterm f)=(hterm g))->
   ((hterm f)=(hterm (suma_app f g)))->
    (eqQ (hcoef (suma_app f g)) (plusQ (hcoef f) (hcoef g))).
Intros.
Apply eqQ_trans with (coef (suma_app f g) (hterm (suma_app f g))).
Auto.
 
Apply eqQ_trans with (plusQ (coef f (hterm f)) (coef g (hterm g))).
Rewrite <- H2.
(Rewrite <- H1; Auto).
 
Auto.
Save.










Lemma hterm_eq_suma_Ttm:(f,g:pol)(full_term_pol f)->
 (full_term_pol g)->(~(equpol (suma_app f g) vpol))->
   (eqQ (hcoef f) (multQ_neg (hcoef g)))->
    ((hterm f)=(hterm g))->
     (Ttm (hterm (suma_app f g)) (hterm f)).
Intros.
(Elim (eq_tm_dec (hterm (suma_app f g)) (hterm f)); Intros).
(Cut (eqQ (hcoef (suma_app f g)) (plusQ (hcoef f) (hcoef g))); Intros).
(Cut (eqQ (hcoef (suma_app f g)) OQ); Intros).
(Cut ~(eqQ (hcoef (suma_app f g)) OQ); Intros).
(Elim H6; Auto).
 
(Apply cond_ht_pol; Auto).
 
(Apply eqQ_trans with (plusQ (hcoef f) (hcoef g)); Auto).
 
(Apply aux2_hterm_eq_suma_Ttm; Auto).
 
(Apply aux1_hterm_eq_suma_Ttm with g; Trivial).
(Apply occ_n_vpol; Auto).
Save.









Lemma hterm_pol_opp: (f:pol)(full_pol f)->
 ~(equpol f vpol)->((hterm f)=(hterm (pol_opp f))).
Induction f.
Intros.
(Elim H0; Auto).
 
(Induction m; Intros).
Simpl.
Transitivity y0.
Auto.
 
Symmetry.
Apply full_hterm.
Inversion H0.
(Apply full_pol_cons; Auto).
Save.
Hints Resolve hterm_pol_opp.








Lemma hterm_pol_opp_term: (f:pol)(full_term_pol f)->
 ~(equpol f vpol)->((hterm f)=(hterm (pol_opp f))).
Intros.
(Elim (can_fun f); Trivial).
Intros.
Elim y; Intros; Clear y.
Replace (hterm f) with (hterm x).
Replace (hterm (pol_opp f)) with (hterm (pol_opp x)).
(Apply hterm_pol_opp; Trivial).
EAuto.
 
Auto.
 
Auto.
Save.
Hints Resolve hterm_pol_opp_term.







Lemma hcoef_pol_opp:(f:pol)(full_pol f)->
 (~(equpol f vpol))->
  (eqQ (hcoef f) (multQ_neg (hcoef (pol_opp f)))). 
Induction f.
Intros.
Elim H0; Auto.
 
Induction m; Intros.
Apply eqQ_trans with y.
(Apply full_hcoef; Trivial).
 
Apply eqQ_trans
 with (multQ_neg
        (coef (pol_opp (cpol (y,y0) p))
          (hterm (pol_opp (cpol (y,y0) p))))).
Apply eqQ_trans
 with (coef (cpol (y,y0) p) (hterm (pol_opp (cpol (y,y0) p)))).
Replace (hterm (pol_opp (cpol (y,y0) p))) with (hterm (cpol (y,y0) p)).
Replace (hterm (cpol (y,y0) p)) with y0.
Simpl.
Elim (eq_tm_dec y0 y0).
Intros.
Inversion H0.
Apply eqQ_trans with (plusQ y OQ).
Auto.
 
Auto.
 
(Intro e; Elim e; Auto).
 
(Symmetry; Apply full_hterm; Trivial).
 
(Apply hterm_pol_opp; Trivial).
 
Auto.
 
(Apply eq_mulQ_neg; Auto).
Save.
Hints Resolve hcoef_pol_opp.







Lemma hcoef_pol_opp_term: (f:pol)(full_term_pol f)->
 (~(equpol f vpol))->
  (eqQ (hcoef f) (multQ_neg (hcoef (pol_opp f)))).
Intros.
Apply eqQ_trans with (coef f (hterm f)).
Auto.
 
Apply eqQ_trans with (multQ_neg (coef (pol_opp f) (hterm (pol_opp f)))).
Apply eqQ_trans with (coef f (hterm (pol_opp f))).
Auto.
 
Auto.
 
Apply eq_mulQ_neg; Auto.
Save.





Lemma eq_pol_opp_hcoef: (f,g:pol)(full_term_pol f)->
 (full_term_pol g)->(~(equpol f vpol))->
  (~(equpol g vpol))->(eqQ (hcoef f) (hcoef g))->
  (eqQ (hcoef (pol_opp f)) (hcoef (pol_opp g))).
Intros.
Apply eqQ_trans with (multQ_neg (hcoef (pol_opp (pol_opp f)))).
Apply hcoef_pol_opp_term; Auto.
 
Apply eqQ_trans with (multQ_neg (hcoef (pol_opp (pol_opp g)))).
Apply eq_mulQ_neg.
Apply eqQ_trans with (hcoef g).
Auto.
 
(Apply eqQ_trans with (hcoef f); Auto).
 
Apply eqQ_sym.
Apply hcoef_pol_opp_term; Auto.
Save.




Lemma eq_pol_opp_hterm: (f,g:pol)(full_term_pol f)->
 (full_term_pol g)->(~(equpol f vpol))->
  (~(equpol g vpol))->(hterm f)=(hterm g)->
  (hterm (pol_opp f))=(hterm (pol_opp g)).
Intros.
Transitivity (hterm f).
(Symmetry; Auto).
 
(Transitivity (hterm g); Auto).
Save.


*)

(* Cambiado debido a hterm vpol

Lemma aux_no_hterm_Ttm_in_red: (f,g,fj:pol)(red fj f g)->
 (~(equpol g vpol))->
  (Ttm (hterm g) (hterm f)) \/ (hterm g)=(hterm f).

Intros.
Inversion H; Intros.
Cut ~(equpol f vpol); Intros.
Cut ~(eqQ (coef f t) OQ); Intros.
Cut (full n t); Intros.
Cut (full_term_pol (pol_opp (mult_m fj
        ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))); Intros.
Cut t=(hterm f)\/(Ttm t (hterm f)); Intros.
Elim H12; Intros; Clear H12.
Left.
Rewrite H13 in H7.
Rewrite H13 in H6.
Replace (hterm g) with (hterm (suma_app f
    (pol_opp (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))))).
Apply hterm_eq_suma_Ttm; Trivial.
 
Apply eq_nvpol with g; Trivial.

Rewrite H13; Auto.
 
Rewrite H13.
Apply eqQ_trans with (multQ_neg (hcoef (pol_opp f))).
Apply hcoef_pol_opp_term; Trivial.
 
Apply eq_mulQ_neg.
Apply eq_pol_opp_hcoef; Trivial.

Apply full_mult_m; Auto.
 
Apply contr_mult_nz_monom; Trivial.

Rewrite <- H13.
Apply no_divQ_zero; Auto.
 
Auto.
 
Apply eqQ_trans with (multQ (hcoef fj) (mon_coef
  ((divQ (coef f (hterm f)) (hcoef fj)),(div_term (hterm f) (hterm fj))))).
Apply hcoef_mult; Trivial.

Auto.
 
Simpl.
Apply no_divQ_zero.
Apply comp_nOQ with (hcoef f); Auto.
 
Apply cond_ht_pol; Auto.
 
Simpl.
Apply eqQ_trans with (multQ (hcoef fj) (divQ (hcoef f) (hcoef fj))).
Apply multQ_comp_l; Auto.
 
Apply eqQ_trans with (multQ (divQ (hcoef f) (hcoef fj)) (hcoef fj)); Trivial.

Apply eqQ_trans with (divQ (multQ (hcoef f) (hcoef fj)) (hcoef fj)); Auto.

Apply eqQ_trans with (divQ (multQ (hcoef fj) (hcoef f)) (hcoef fj)); Auto.
 
Transitivity (hterm (pol_opp f)).
Apply hterm_pol_opp_term; Trivial.
 
Apply eq_pol_opp_hterm; Trivial.

Apply full_mult_m; Auto.
 
Apply contr_mult_nz_monom; Trivial.

Apply no_divQ_zero; Auto.
 
Auto.
 
Transitivity (term_mult (hterm fj) (mon_term
               ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))); Auto.

Simpl.
Rewrite H13.
Apply divis_im_divt with n; Auto.

Symmetry.
Apply hterm_mult_m; Trivial.

Simpl.
Apply term_div_full; Auto.
 
Simpl.
Apply no_divQ_zero; Auto.
 
Apply eq_hterm; Trivial.

Apply full_term_suma_app; Trivial.
 
Rewrite H13; Auto.

Right.
Replace (hterm g) with (hterm (suma_app f (pol_opp (mult_m fj
           ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))))); Auto.

Apply hterm_suma_Ttm; Trivial.
 
Replace (hterm (pol_opp (mult_m fj
                ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))) with 
      (hterm (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).
Replace (hterm (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))
 with (term_mult (hterm fj) 
       (mon_term ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).
Simpl.
Replace (term_mult (hterm fj) (div_term t (hterm fj))) with t; Trivial.

Apply divis_im_divt with n; Auto.
 
Symmetry.
Apply hterm_mult_m; Trivial.

Simpl; Auto.

 
Simpl.
Apply no_divQ_zero; Auto.
 
Apply hterm_pol_opp_term.
Apply full_mult_m; Auto.
 
Apply contr_mult_nz_monom; Trivial.

Apply no_divQ_zero; Auto.
 
Auto.

Elim (eq_tm_dec t (hterm f)); Intros.
Left; Trivial.

Right.
Apply Ttm_pol_hterm; Auto.

Apply full_term_opp.
Apply full_mult_m; Auto.

Apply full_coef with f; Trivial.

Auto.

Apply term_in_pol_nvpol with t; Auto.
Save.



Lemma aux_no_hterm_Ttm_in_red: (f,g,fj:pol)(red fj f g)->~(equpol g vpol)->
                           (Ttm (hterm g) (hterm f)) \/ (hterm g)=(hterm f).

Intros.
Inversion H; Intros.
Cut ~(equpol f vpol); Intros.
Cut ~(eqQ (coef f t) OQ); Intros.
Cut (full n t); Intros.
Cut (full_term_pol (pol_opp (mult_m fj
        ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))); Intros.
Cut t=(hterm f)\/(Ttm t (hterm f)); Intros.
Elim H12; Intros; Clear H12.
Left.
Rewrite H13 in H7.
Rewrite H13 in H6.
Replace (hterm g) with (hterm (suma_app f
    (pol_opp (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))))).
Apply hterm_eq_suma_Ttm; Trivial.
 
Apply eq_nvpol with g; Trivial.

Rewrite H13; Auto.
 
Rewrite H13.
Apply eqQ_trans with (multQ_neg (hcoef (pol_opp f))).
Apply hcoef_pol_opp_term; Trivial.
 
Apply eq_mulQ_neg.
Apply eq_pol_opp_hcoef; Trivial.

Apply full_mult_m; Auto.

(* Eliminado con hterm vpol
Apply contr_mult_nz_monom; Trivial.

Rewrite <- H13.
Apply no_divQ_zero; Auto.
 
Auto.
*)

Apply eqQ_trans with (multQ (hcoef fj) (mon_coef
  ((divQ (coef f (hterm f)) (hcoef fj)),(div_term (hterm f) (hterm fj))))).
Apply hcoef_mult; Trivial.

Auto.

(* Eliminado con hterm vpol
Simpl.
Apply no_divQ_zero.
Apply comp_nOQ with (hcoef f); Auto.
 
Apply cond_ht_pol; Auto.
*)

Simpl.
Apply eqQ_trans with (multQ (hcoef fj) (divQ (hcoef f) (hcoef fj))).
Apply multQ_comp_l; Auto.
 
Apply eqQ_trans with (multQ (divQ (hcoef f) (hcoef fj)) (hcoef fj)); Trivial.

Apply eqQ_trans with (divQ (multQ (hcoef f) (hcoef fj)) (hcoef fj)); Auto.

Apply eqQ_trans with (divQ (multQ (hcoef fj) (hcoef f)) (hcoef fj)); Auto.
 
Transitivity (hterm (pol_opp f)).
Apply hterm_pol_opp_term; Trivial.
 
Apply eq_pol_opp_hterm; Trivial.

Apply full_mult_m; Auto.

(* Eliminado con hterm vpol
Apply contr_mult_nz_monom; Trivial.

Apply no_divQ_zero; Auto.
 
Auto.
*)

Transitivity (term_mult (hterm fj) (mon_term
               ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).(*  Auto.*)

Simpl.
Rewrite H13.
Apply divis_im_divt with n; Auto.

Symmetry.
Apply hterm_mult_m; Trivial.

Simpl.
Apply term_div_full; Auto.
 
Simpl.
Apply no_divQ_zero; Auto.
 
Apply eq_hterm; Trivial.

Apply full_term_suma_app; Trivial.
 
Rewrite H13; Auto.

Right.
Replace (hterm g) with (hterm (suma_app f (pol_opp (mult_m fj
           ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))))); Auto.

Apply hterm_suma_Ttm; Trivial.
 
Replace (hterm (pol_opp (mult_m fj
                ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))) with 
      (hterm (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).
Replace (hterm (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))
 with (term_mult (hterm fj) 
       (mon_term ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).
Simpl.
Replace (term_mult (hterm fj) (div_term t (hterm fj))) with t; Trivial.

Apply divis_im_divt with n; Auto.
 
Symmetry.
Apply hterm_mult_m; Trivial.

Simpl; Auto.

 
Simpl.
Apply no_divQ_zero; Auto.
 
Apply hterm_pol_opp_term.
Apply full_mult_m; Auto.

Elim (eq_tm_dec t (hterm f)); Intros.
Left; Trivial.

Right.
Apply Ttm_pol_hterm; Auto.

Apply full_term_opp.
Apply full_mult_m; Auto.

Apply full_coef with f; Trivial.

Auto.

Apply term_in_pol_nvpol with t; Auto.
Save.
*)

Lemma aux_no_hterm_Ttm_in_red: (f,g,fj:pol)(red fj f g)->
                           (Ttm (hterm g) (hterm f)) \/ (hterm g)=(hterm f).

Intros.
Elim (vpol_dec_full_term g).
Inversion H.
Intros.
Elim (vpol_dec_full_term f); Intros; Trivial.

Right.
Transitivity (hterm vpol).
Apply eq_hterm; Trivial.

Apply eq_hterm; Auto.

Elim (eq_tm_dec (hterm f) (n_term_O n)); Intros.
Right.
Rewrite a0.
Transitivity (hterm vpol).
Apply eq_hterm; Trivial.

Apply hterm_vpol.

Left.
Replace (hterm g) with (n_term_O n).
Apply ord_adm1; Auto.

Transitivity (hterm vpol).
Symmetry.
Apply hterm_vpol.

Apply eq_hterm; Auto.

Intro H0.
Inversion H; Intros.
Cut ~(equpol f vpol); Intros.
Cut ~(eqQ (coef f t) OQ); Intros.
Cut (full n t); Intros.
Cut (full_term_pol (pol_opp (mult_m fj
        ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))); Intros.
Cut t=(hterm f)\/(Ttm t (hterm f)); Intros.
Elim H12; Intros; Clear H12.
Left.
Rewrite H13 in H7.
Rewrite H13 in H6.
Replace (hterm g) with (hterm (suma_app f
    (pol_opp (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))))).
Apply hterm_eq_suma_Ttm; Trivial.
 
Apply eq_nvpol with g; Trivial.

Rewrite H13; Auto.
 
Rewrite H13.
Apply eqQ_trans with (multQ_neg (hcoef (pol_opp f))).
Apply hcoef_pol_opp_term; Trivial.
 
Apply eq_mulQ_neg.
Apply eq_pol_opp_hcoef; Trivial.

Apply full_mult_m; Auto.

Apply eqQ_trans with (multQ (hcoef fj) (mon_coef
  ((divQ (coef f (hterm f)) (hcoef fj)),(div_term (hterm f) (hterm fj))))).
Apply hcoef_mult; Trivial.

Auto.
 
Simpl.
Apply eqQ_trans with (multQ (hcoef fj) (divQ (hcoef f) (hcoef fj))).
Apply multQ_comp_l; Auto.
 
Apply eqQ_trans with (multQ (divQ (hcoef f) (hcoef fj)) (hcoef fj)); Trivial.

Apply eqQ_trans with (divQ (multQ (hcoef f) (hcoef fj)) (hcoef fj)); Auto.

Apply eqQ_trans with (divQ (multQ (hcoef fj) (hcoef f)) (hcoef fj)); Auto.
 
Transitivity (hterm (pol_opp f)).
Apply hterm_pol_opp_term; Trivial.
 
Apply eq_pol_opp_hterm; Trivial.

Apply full_mult_m; Auto.
 
Transitivity (term_mult (hterm fj) (mon_term
               ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))); Auto.

Simpl.
Rewrite H13.
Apply divis_im_divt with n; Auto.

Symmetry.
Apply hterm_mult_m; Trivial.

Simpl.
Apply term_div_full; Auto.
 
Simpl.
Apply no_divQ_zero; Auto.
 
Apply eq_hterm; Trivial.

Apply full_term_suma_app; Trivial.
 
Rewrite H13; Auto.

Right.
Replace (hterm g) with (hterm (suma_app f (pol_opp (mult_m fj
           ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))))); Auto.

Apply hterm_suma_Ttm; Trivial.
 
Replace (hterm (pol_opp (mult_m fj
                ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))) with 
      (hterm (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).
Replace (hterm (mult_m fj ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj)))))
 with (term_mult (hterm fj) 
       (mon_term ((divQ (coef f t) (hcoef fj)),(div_term t (hterm fj))))).
Simpl.
Replace (term_mult (hterm fj) (div_term t (hterm fj))) with t; Trivial.

Apply divis_im_divt with n; Auto.
 
Symmetry.
Apply hterm_mult_m; Trivial.

Simpl; Auto.

 
Simpl.
Apply no_divQ_zero; Auto.
 
Apply hterm_pol_opp_term.
Apply full_mult_m; Auto.

Elim (eq_tm_dec t (hterm f)); Intros.
Left; Trivial.

Right.
Apply Ttm_pol_hterm; Auto.

Apply full_term_opp.
Apply full_mult_m; Auto.

Apply full_coef with f; Trivial.

Auto.

Apply term_in_pol_nvpol with t; Auto.

Inversion H; Auto.
Save.

Lemma no_hterm_Ttm_in_red: (f,g,fj:pol)(t:term)(full n t)->(Ttm (hterm f) t)->
         (red fj f g)->(Ttm (hterm g) t).

Intros.
Inversion H1.
Cut (Ttm (hterm g) (hterm f))\/(hterm g)=(hterm f); Intros.
Elim H9; Intros; Clear H9.
Apply Ttm_trans with (hterm f) n; Auto.
 
Rewrite <- H10 in H0; Auto.
 
Apply aux_no_hterm_Ttm_in_red with fj; Trivial.
Save.
Hints Resolve no_hterm_Ttm_in_red.

(* Cambiado con hterm vpol

Lemma no_hterm_Ttm_in_red: (f,g,fj:pol)(t:term)(full n t)->
 (Ttm (hterm f) t)->(red fj f g)->(~(equpol g vpol))->
    (Ttm (hterm g) t).
Intros.
Inversion H1.
(Cut (Ttm (hterm g) (hterm f))\/(hterm g)=(hterm f); Intros).
(Elim H10; Intros; Clear H10).
Apply Ttm_trans with (hterm f) n; Auto.
 
Rewrite <- H11 in H0; Auto.
 
Apply aux_no_hterm_Ttm_in_red with fj; Trivial.
Save.
Hints Resolve no_hterm_Ttm_in_red.

*)


Lemma no_hterm_Ttm_in_red_bis: (f,g,fj:pol)(t:term)(full n t)->
 ((t1:term)(term_in_pol f t1)->(Ttm t1 t))->(red fj f g)->
  ((t2:term)(term_in_pol g t2)->(Ttm t2 t)).
Intros.
Inversion H1.
(Elim eq_tm_dec with t2 (hterm g); Intros).
Rewrite a.
Cut (Ttm (hterm f) t); Intros.
Cut ~(equpol g vpol); Intros.
(Apply no_hterm_Ttm_in_red with f fj; Auto).
 
EAuto.
 
EAuto.
 
Cut (Ttm (hterm f) t); Intros.
Cut ~(equpol g vpol); Intros.
(Apply Ttm_trans with (hterm g) n; Auto).
EAuto.
 
Apply no_hterm_Ttm_in_red with f fj; Auto.
 
EAuto.
 
EAuto.
Save.
Hints Resolve no_hterm_Ttm_in_red_bis.

(*
Lemma term_in_Ttm: (fj:pol)(t,t',t0:term)(a:Q)(~(eqQ a OQ))->
 (full_term_pol fj)->(full n t)->(full n t')->(full n t0)->
  (~(equpol fj vpol))->(Ttm t0 t)->(term_div (hterm fj) t0)->
   (term_in_pol (mult_m fj 
    ((divQ a (hcoef fj)),(div_term t0 (hterm fj)))) t')->
       (Ttm t' t).
Intros.
Cut (hterm (mult_m fj ((divQ a (hcoef fj)),(div_term t0 (hterm fj)))))
     =t0; Intros.
Elim (eq_tm_dec t'
       (hterm
         (mult_m fj ((divQ a (hcoef fj)),(div_term t0 (hterm fj))))));
Intros.
Rewrite y.
(Rewrite H8; Trivial).
 
(Cut (Ttm t'
       (hterm
         (mult_m fj ((divQ a (hcoef fj)),(div_term t0 (hterm fj))))));
 Intros).
(Apply Ttm_trans with t0 n; Trivial).
(Rewrite <- H8; Trivial).
 
Auto.
 
Apply hterm_mult_m2; Auto.

Apply no_divQ_zero; Auto.
Save.
Hints Resolve term_in_Ttm.

*)